#include <SD.h>                      // need to include the SD library
#define SD_ChipSelectPin 4  //using digital pin 4 on arduino nano 328, can use other pins
#include <TMRpcm.h>           //  also need to include this library...
#include <SPI.h>

TMRpcm tmrpcm;   // create an object for use in this sketch

int inPin = 7;    // pulse input pin
int ledPin = 2;    // led out pin

unsigned long starttime = 0; //pulse start time
unsigned long elapsed_time = 0; //pulse duration
unsigned long total_time = 0; //pulse duration
bool counting = false;

int entered_digit=0;
int first_pulse=0;
int digit_detected=0;
unsigned long digits_enter_start = 0; //start of first pulse
unsigned long digits_enter_duration = 100; //wheel full rotation

void setup(){
  tmrpcm.speakerPin = 9; //5,6,11 or 46 on Mega, 9 on Uno, Nano, etc
  //tmrpcm.setVolume(7); //max7
 
pinMode(inPin, INPUT);    // sets the digital pin 7 as input
pinMode(ledPin, OUTPUT);

  Serial.begin(9600);
  if (!SD.begin(SD_ChipSelectPin)) {  // see if the card is present and can be initialized:
    Serial.println("SD fail");  
      digitalWrite(ledPin,HIGH);
      delay(300);
      digitalWrite(ledPin,LOW);
      delay(300);
      digitalWrite(ledPin,HIGH);
      delay(300);
      digitalWrite(ledPin,LOW);
      delay(300);
      digitalWrite(ledPin,HIGH);
      delay(300);
      digitalWrite(ledPin,LOW);
    return;   // don't do anything more if not
  }else{
    Serial.println("SD ok");
    digitalWrite(ledPin,HIGH);
  }
 
}



void loop(){  

if ( digitalRead(inPin) == LOW && counting==false)
{
  starttime=millis();
  counting=true; 
}


if (digitalRead(inPin) == HIGH && counting==true) {
     counting = false;
     elapsed_time = millis()- starttime;
     total_time = elapsed_time;
     elapsed_time=0; 
    // Serial.print("Total_time: "); 
    // Serial.println(total_time); 
        if (total_time>=10 && total_time<75 ){
            if(first_pulse==0){first_pulse=1;}
            digit_detected=1;
            entered_digit=entered_digit+1;
            digits_enter_duration+=130;
            }
}


    if(digit_detected==1){
        if(first_pulse==1){
        digits_enter_start=millis();
        first_pulse=2;
        }
         if ( (millis()-digits_enter_start)>digits_enter_duration && first_pulse==2 ){
         Serial.print("Digit: ");
         Serial.println(entered_digit);
         digit_play(entered_digit);
         entered_digit=0;
         digit_detected=0;
         first_pulse=0;
         digits_enter_duration=100;
         }   
    }

} //end of main loop


void digit_play(int digit){
  if(digit==1){ tmrpcm.play("dtmf-11.wav");}
  if(digit==2){ tmrpcm.play("dtmf-22.wav");}
  if(digit==3){ tmrpcm.play("dtmf-33.wav");}
  if(digit==4){ tmrpcm.play("dtmf-44.wav");}
  if(digit==5){ tmrpcm.play("dtmf-55.wav");}
  if(digit==6){ tmrpcm.play("dtmf-66.wav");}
  if(digit==7){ tmrpcm.play("dtmf-77.wav");}
  if(digit==8){ tmrpcm.play("dtmf-88.wav");}
  if(digit==9){ tmrpcm.play("dtmf-99.wav");}
  if(digit==10){ tmrpcm.play("dtmf-00.wav");}
}
